;Include Dos.mac

Inter      Segment At 00h
	   Org     1Ch*04h
Time       Dw      2 Dup( ? )
Inter      Ends

Code       Segment Para Public
	   Assume  Cs: Code
	   Org     100h

Start:     Jmp     Near Ptr Init


Temp       Dw      04h
Octava     Dw      48
Cur_Nota   Dw      00h
Duration   Dw      00h
First      Db      00h
Flag       Db      01h
Psp        Dw      ?
Slov       Db      10
Lon_data   Dw      Offset _data
Lon_TIME   Dw      Offset _TIME


Old_Int_9  Label Dword
Int9_Off   Dw    ?
Int9_Seg   Dw    ?

Soundd	proc	near
	Push       Bp
	Mov        Bp,Sp
	Push       Di
	Push       Si
	Push       Dx
	Push       Bx
	Push       Cx
	Push       Ax


	Mov	   Di,[bp+4]
	Mov	   Bx,[bp+6]

	Mov	   al,0B6H
	Out	   43H,al
	Mov	   Dx,14H
	Mov	   AX,4F38H
	Div	   Di
	Out	   42H,al
	Mov	   al,ah
	Out	   42H,al
	In	   al,61H
	Mov	   ah,al
	Or	   al,03H
	Out	   61H,al
	Mov        Cl,02h
	Shr        Bx,Cl

	Xor        Ax,Ax
	Int        1Ah
	Add        Bx,Dx

Nextr:  Xor        Ax,Ax
	Int        1Ah
	Cmp        Dx,Bx
	Jnz        Nextr

	Mov	   al,ah
	Out	   61H,al

	Pop        Ax
	Pop        Cx
	Pop        Bx
	Pop        Dx
	Pop        Si
	Pop        Di
	Pop        Bp
	ret

Soundd	endp


Main       Proc      Far
           Cli
           Cmp       Flag,00h
           Jne       Let
	   Jmp       Near Ptr Exitt

Let:       Push      Ax
           Push      Es
           Push      Cx
	   Push      Si
           Push      Di
           Push      Ds
           Push      Dx
           Push      Cs
	   Pop       Ds

	   Cmp       First,01h
           Jne       Count

           Sti
           Xor       ah,ah
           Int       1Ah
           Cli
           Cmp       Dx,Duration
           Jb        Exit

Next:      Inc       Cur_Nota
Count:     Mov       First,01h
           Lea       Si,Music
	   Add       Si,Cur_Nota
           Cld
           Lodsb
           Or        al,al
           Jne       Continue
           Mov       Octava,48
	   Mov       Cur_Nota,00h
	   Jmp       Short   Count

Continue:  Cmp       al,'>'
           Jne       Down
           Add       Octava,12
           Jmp       Short   Next

Down:      Cmp       al,'<'
           Jne       Not_Down
           Sub       Octava,12
           Jmp       Short   Next

Not_Down:  Cmp      al,'-'
	   Jne      Nota_Anal

           In       al,61h
           And      al,0FCh
           Out      61h,al

Regime:    Sti
	   Xor       ah,ah
           Int       1Ah
           Cli
           Add       Dx,Temp
           Mov       Duration,Dx

Exit:      Pop       Dx
           Pop       Ds
           Pop       Di
           Pop       Si
           Pop       Cx
           Pop       Es
           Pop       Ax
Exitt:     Sti

           Db         0EAh
Old_Time   Label      Word
           Dw         2 Dup( ? )

Nota_Anal: Push       Cs
	   Pop        Es
           Mov        Si,Offset Nota_Code
           Mov        Di,Si
           Cld
           Mov        Cx,12
           Repne      Scasb
           Jne        Exit
           Dec        Di
           Xchg       Si,Di
           Sub        Si,Di
           Add        Si,Octava
           Shl        Si,01h
           Add        Si,Offset Notes
	   Lodsw
Sound:     Mov        Cx,Ax
	   In         al,61h
	   Or         al,03h
	   Out        61h,al
	   Mov        al,0B6h
	   Out        43h,al
	   Mov        al,Cl
	   Out        42h,al
	   Mov        al,Ch
	   Out        42h,al
	   Jmp        Short  Regime

Main       Endp

Key       Proc
	  Pushf
	  Call Dword Ptr Old_Int_9

	  Cli
	  Pushf
	  Push  Es
	  Push  Ax
	  Xor   Ax,Ax
	  Mov   Es,Ax
	  Mov   Al,Byte Ptr Es:[ 417h ]
	  Mov   ah,al
	  Test  al,02h
	  Jnz   Step
          Jmp   Near Ptr Tak
Step:     In    al,60h
          Cmp  al,47h
          Jne  St1
          Push_All
          Cli
          Mov     Ax,Psp
          Mov     Ds,Ax
          Mov     Es,Ax
          Mov     ah,Flag
	  Mov     Flag,00h
          Push    Ax
          Call    Near Ptr Pisk
          Cli
          Pop     Ax
	  Mov     Flag,Ah
          Pop_All
          Jmp Near Ptr Nott

St1:	  Cmp   al,53h
	  Jne   Watch
	  Jmp   Near Ptr Already

Watch:    Cmp   al,52h
	  Je    Sw
          Jmp   Near Ptr Tak

Sw:	  In    al,21h
	  Or    al,02h
	  Out   21h,al
          Push_All
          Mov   Ah,15
          Int   10h
          Cmp   al,03h
          Je    N1
          Cmp   al,02h
          Jne   Ert
N1:       Or    Bh,Bh
          Jnz   Ert

          Mov   Ax,0B800h
          Mov   Ds,Ax
          Xor   Di,Di
          Mov   Si,Offset Screen
          Mov   Cx,2000
Str01:    Mov   Ax,Ds:[ Di ]
          Mov   Cs:[ Si ],Ax
          Add   Di,02h
          Add   Si,02h
          Loop  Str01

          Mov   Ax,Psp
          Mov   Ds,Ax
          Mov   Es,Ax
          Mov     ah,Flag
	  Mov     Flag,00h

          Call  Near Ptr Start

          Cli
          Mov   Ax,0003h
          Int   10h
          Mov   Ax,0B800h
          Mov   Ds,Ax
          Xor   Di,Di
          Mov   Si,Offset Screen
          Mov   Cx,2000
Str11:    Mov   Ax,Cs:[ Si ]
          Mov   Ds:[ Di ],Ax
          Add   Di,02h
          Add   Si,02h
          Loop  Str11
Ert:      Pop_All
	  And    al,0FDh
	  Out   21h,al
	  Jmp   Near Ptr Nott

Tak:      Cmp   Flag,00h
	  Jne   Off
	  Test  ah,10h
	  Jz    Nott
	  Mov   Flag,01h
	  Jmp   Short Nott

Off:      Test  ah,10h
	  Jne   Uvel
	  Mov   Flag,00h
	  In    al,61h
	  And   al,0FCh
	  Out   61h,al
	  Jmp   Short Nott

Uvel:     Test ah,02h
	  Jz   Nott
	  In   al,60h
	  Cmp  Al,48h
	  Je   Inc_Temp
	  Cmp  al,50h
	  Jne  Nott
	  Cli
	  Dec  Cs:Temp
	  Sti
	  Jmp  Short Nott
Inc_Temp: Cli
	  Inc  Cs:Temp
	  Sti

Nott:     Pop  Ax
	  Pop  Es
	  Popf
	  Sti
	  Iret

Key       Endp

Point   Proc Near
	Push    Di
	Push    Si
	Push    Dx
	Push    Bx
	Push    Ds
	Push    Es

          Mov   Ax,Psp
          Mov   Ds,Ax
          Mov   Es,Ax

	Mov	   Di,Cs:Lon_data
	Mov	   SI,Cs:Lon_TIME
	Sti
Nextt:  Mov        Dx,Ds:[Di]
	Cmp	   Dx,0FFFFH
	je	   short Exit1
	Mov	   Bx,Ds:[Si]
	Push	   Bx
	Push	   Dx
	Call	   Near ptr Soundd
        Cli
	Add	   SP,04H
	Add	   Si,02H
	Add	   Di,02H
        Clc
Letin:  Mov	   Cs:Lon_data,Di
	Mov	   Cs:Lon_TIME,Si
        Pop	Es
	Pop	Ds
	Pop     Bx
	Pop     Dx
	Pop     Si
	Pop     Di
        Ret
	;jne	   short Nextt


Exit1:  Cli
	Mov     Flag,Ah
        Mov     Di,Offset _data
        Mov     Si,Offset _TIME
        Stc
        Jmp    Short Letin

Point   Endp


Int_2F    Proc  Far
	  Sti
	  Cmp   Ax,0FEDCh
	  Jne   No_My
	  Mov   Ax,0CDEFh
	  Iret

No_My:    Db    0EAh
Int2F_Off Dw    ?
Int2F_Seg Dw    ?

Int_2F    Endp

Already    Proc       Near
	   Push       Bx
	   Push       Dx
	   Push       Ds

	   Mov        Ax,3509h
	   Int        21h
	   Mov        Ax,Cs
	   Mov        Dx,Es
	   Cmp        Dx,Ax
	   Jne         Error

	   Cmp        Bx,Offset Key
	   Jne        Error

	   Mov        Ax,351Ch
	   Int        21h
	   Mov        Ax,Cs
	   Mov        Dx,Es
	   Cmp        Dx,Ax
	   Jne        Error

	   Cmp        Bx,Offset Main
	   Jne        Error

	   Mov        Ax,352Fh
	   Int        21h
	   Mov        Ax,Cs
	   Mov        Dx,Es
	   Cmp        Dx,Ax
	   Jne        Error

	   Cmp        Bx,Offset Int_2F
	   Jne        Error

	   Mov        Dx,Word Ptr Cs:Int9_Off
	   Mov        Ax,Word Ptr Cs:Int9_Seg
	   Mov        Ds,Ax
	   Mov        Ax,2509h
	   Int        21h

	   Mov        Dx,Word Ptr Cs:Int2F_Off
	   Mov        Ax,Word Ptr Cs:Int2F_Seg
	   Mov        Ds,Ax
	   Mov        Ax,252Fh
	   Int        21h

	   Mov        Dx,Word Ptr Es:Old_Time
	   Mov        Ax,Word Ptr Es:Old_Time[ 02h ]
	   Mov        Ds,Ax
	   Mov        Ax,251Ch
	   Int        21h

	   In         al,61h
	   And        al,0FCh
	   Out        61h,al

	   Mov        Ax,Psp
	   Mov        Es,Ax
	   Mov        ah,49h
	   Int        21h

	   Jmp        Short Et

Error:	   Mov        Ax,100
	   Push       AX
	   Mov        Ax,440
	   Push       Ax
	   Call       Near Ptr Soundd
	   Add        Sp,04h


Et:	   Pop	      Ds
	   Pop        Dx
	   Pop        Bx
	   Pop  Ax
	   Pop  Es
	   Popf
	   Sti
	   Iret

Already    Endp

Al_Set     Db      10,13
	   Db      'ணࠬ 㦥 饭.',10,13
	   Db      '    Scroll Lock  ',10,13
	   Db      '<Left>Shift+Ins.',10,13,10,24h

           Db      '  ணࠬ 뫨 ᯮ짮  ,'
           Db      '  뫨 ⢮  㣨 ஢.  ਭᨬ '
           Db      ' ⨬ ࠬ  ᯮ짮  ⬮, '
           Db      '  ᮣ.   ⥭㥬  ⢮   '
           Db      '  ,    ᮡࠫ ஭  ணࠬ,'
           Db      '    襬     ஦, '
           Db      ' ᤥ ⭮ 祫.  .'

Text       Db      10,13
	   Db      '    몠쭠 ணࠬ ᯥ樠쭮 ᠭ',10,13
	   Db      ' ~',8Ch,'窨.'
	   Db      10,13,10,13
	   Db      '   ~',0Ah,'ਭ !   ~',07,' ⥡ ⠭ 筮  ',10,13
	   Db      'ணࠬ, ᯮ ,  ⥡ ⠭ .'
	   Db      10,13,10,13
	   Db      '~',0Eh,'ࠬ ᪠:',10,13,10
           Db      '   ~',15,'砫    ~',10,'<Shift>+Ins,',10,13
           Db      '~',15,' ⥬ ~',10,'<Shift>+Home.',10,13
           Db      '   ~',15,'᫨   ᬮ  ᥡ  ઠ',10,13
           Db      '   ~',10,'<Shift>+End.~',15,10,13,10,00h

Leting     Db      10,13
           Db      'Core resident musical executor. Version 1.0',10,13
           Db      'Copyright (C) FBA 1993',10,13,10,13,24h

Contin     Db      'In order to hear music use switch /G',10,13,10,24h


Text_Help  Db      'ࠬ ᪠ ணࠬ:',10,13
	   Db	   'Music   [ /? ] | [ /G ] | [ /N ]',10,13,10,13
	   Db      '     [ /? ] - 뢮  ᯫ  ᪠,',10,13
	   Db      '        [ /G ] -  ணࠬ',10,13
           Db	   '        [ /N ] -  ணࠬ  뢮',10,13
           Db      '                 ⥪  ᯮ짮 ண-',10,13
           Db      '                 ࠬ.',10,13,10,24h

Text_Go    Db      ' ᯮ짮:',10,13
           Db      'Scroll Lock - 祭 / 몫祭 䮭 ,',10,13
           Db      'Shift+Up    - 㬥襭 ⥬ ,',10,13
           Db      'Shift+Down  - 㢥祭 ⥬ ,',10,13
           Db      'Shift+Ins   -  ୠ⨢ 모,',10,13
           Db      'Shift+Home  - 訢   ,',10,13
           Db      'Shift+Del   - ⨥ ணࠬ  .',10,13
           Db      'Shift+End   - ᬮ ઠ',10,13,10,24h

Ega_Not    Db      10,13,'You have not EGA monitir',10,13,24h

File       Db      'Music.Dat',00h

Err_Text   Db      10,13,'訡  뢠 䠩 Music.Dat',10,13
           Db      '  <Shift>+End  㯭.',10,13,10,24h

Data_File1 Db      0E9h,48h,05h
Data_File2 Db      0CBh,0CBh,0CBh

Re_Ss      Dw      ?
Re_Sp      Dw      ?

Block      Db      14 Dup( 00h )

Init       Proc       Near
	   Assume     Ds: Inter

           Mov        ah,12h
           Mov        Bx,1010h
           Int        10h
           Cmp        Bx,1010h
           Jne        Lesr
           Mov        Dx,Offset Ega_Not
           Mov        Ah,09h
           Int        21h
           Ret


Lesr:      Xor        Bx,Bx
           Mov        Di,Offset Al_Set
Fds:       Add        Bx,Cs:[ Di ]
           Add        Di,02h
           Cmp        Di,Offset Data_File2
           Jb         Fds
           Cmp        Bx,Word Ptr Cs:Pass
           Je         Less
           Cli
           Xor        Ax,Ax
           Mov        Es,Ax
           Mov        Cx,1234h
           Mov        Es:[ 472h ],Cx
           Mov        Ax,0FFFFh
           Push       Ax
           Xor        Ax,Ax
           Push       Ax
           Retf

Less:      Mov        Ax,0FEDCh
	   Int        2Fh
	   Cmp        Ax,0CDEFh
	   Jne        God
	   Mov        Dx,Offset Al_Set
           Mov        ah,09h
           Int        21h
           Ret

God:       Mov        Di,100h
           Mov        Byte Ptr Cs:[ Di ],0B4h
           Inc        Di
           Mov        Byte Ptr Cs:[ Di ],001h
           Inc        Di
           Mov        Byte Ptr Cs:[ Di ],0B5h
           Inc        Di
           Mov        Byte Ptr Cs:[ Di ],020h

           Mov	      Dx,Offset Leting
           Mov        ah,09h
           Int        21h

           Mov        Al,Byte ptr Cs:[ 80h ]
	   Or	      al,al
	   Jnz        Can1

           Mov	      Dx,Offset Contin
           Mov        ah,09h
           Int        21h
           Ret

Can1:      Cld
           Mov        al,'/'
           Mov        Di,81h
           Mov        Cx,128
           Repne      Scasb
           Jcxz       Help

           Mov        al,Cs:[ Di ]
           Cmp        al,'G'
           Je         Go
           Cmp        al,'g'
           Je         Go

           Cmp        al,'N'
           Je         No_Go
           Cmp        al,'n'
           Je         No_Go

           Cmp        al,'S'
           Je         Spesh
           Cmp        al,'s'
           Je         Spesh

Help:      Mov       Dx,Offset Text_Help
           Mov       ah,09h
           Int       21h
           Ret

Spesh:     Mov       Ax,0003h
           Int       10h
           Mov       Ax,0500h
           Int       10h


           Mov       ah,02h
           Xor       Dx,Dx
           Xor       Bh,Bh
           Int       10h

           Mov        Di,Offset Text
           Call       Near Ptr Out_Text
           Jmp        Short No_Go

Go:        Mov       Dx,Offset Text_Go
           Mov       ah,09h
           Int       21h

No_Go:     Mov        Psp,Es


           Mov        Ax,3D01h
           Mov        Dx,Offset File
           Int        21h
           Jc         Errr

           Mov        Bx,Ax
           Mov        ah,40h
           Mov        Cx,03h
           Mov        Dx,Offset Data_file1
           Int        21h
           Jc         Errr

           Mov        ah,3Eh
           Int        21h
           Jc         Errr

           Mov        Re_Ss,Ss
           Mov        Re_Sp,Sp

           Mov        Bx,Offset Pass
           Add        Bx,03h
           Mov        Cl,04h
           Shr        Bx,Cl
           Mov        Ax,Psp
           Mov        Es,Ax
           Mov        ah,4Ah
           Int        21h

           Mov        Ax,4B00h
           Mov        Dx,Offset File
           Mov        Bx,Offset Block
           Int        21h
           Jc         Errr

           Mov        Ax,Cs:Psp
           Mov        Ds,Ax
           Mov        Es,Ax
           Cli
           Mov        Ax,Re_Ss
           Mov        Ss,Ax
           Mov        Ax,Re_Sp
           Mov        Sp,Ax
           Sti

           Mov        Ax,3D01h
           Mov        Dx,Offset File
           Int        21h
           Jc         Errr

           Mov        Bx,Ax
           Mov        ah,40h
           Mov        Cx,03h
           Mov        Dx,Offset Data_file2
           Int        21h
           Jc         Errr

           Mov        ah,3Eh
           Int        21h
           Jnc        Setup


Errr:      Mov        ah,09h
           Mov        Dx,Offset Err_Text
           Int        21h



Setup:     Push       Es
           Push       Ds


           Mov        Ax,Inter
           Mov        Ds,Ax
           Cli
           Mov        Ax,Time
           Mov        Old_Time,Ax
           Mov        Ax,Time[ 02h ]
           Mov        Old_Time[ 02h ],Ax

           Mov        Time,Offset Main
           Mov        Time[ 02h ],Cs
           Sti
           Pop        Ds
           Pop        Es

           Mov        ax,3509h
           Int        21h
           Mov        Word Ptr Cs:Int9_Off,Bx
           Mov        Word Ptr Cs:Int9_Seg,Es

           Mov        Dx,offset Key
           Mov        Ax,2509h
           Int        21h

           Mov        ax,352Fh
           Int        21h
           Mov        Word Ptr Cs:Int2F_Off,Bx
           Mov        Word Ptr Cs:Int2F_Seg,Es

           Mov        Dx,offset Int_2F
           Mov        Ax,252Fh
           Int        21h

           Xor        Ax,Ax
           Mov        Es,Ax
           Or         Byte Ptr Es:[ 417h ],10h

           Push       Es
           Mov        Ax,Cs:[ 2Ch ]
           Mov        Es,Ax
           Mov        ah,49h
           Int        21h
           Pop        Es

           Mov        Dx,Offset Al_Set
           Int        27h


Init       Endp

Out_Text   Proc   Near

           Mov    Bx,0007h
Nt:        Mov    ah,09h

           Mov    al,Cs:[ Di ]
           Or     al,al
           Jz     All
           Cmp    al,10
           Jne    Can2
           Mov    Ax,0300h
           Int    10h
           Xor    Dl,Dl
           Mov    ah,02h
           Int    10h
           Jmp    Short Ett

Can2:      Cmp    al,13
           Jne    Can3
           Mov    Ax,0300h
           Int    10h
           Inc    Dh
           Cmp    Dh,25
           Jb     Can4
           Mov    Dh,24
Can4:      Mov    ah,02h
           Int    10h
           Jmp    Short Ett


Can3:      Cmp    al,'~'
           Jne    Write
           Inc    Di
           Mov    Bl,Cs:[ Di ]
           Inc    Di
           Jmp    Short Nt

Write:     Mov    Cx,01h
           Int    10h
           Mov    Ax,0300h
           Int    10h
           Inc    Dl
           Cmp    Dl,80
           Jb     Can5
           Xor    Dl,Dl
           Inc    Dh
           Cmp    Dh,25
           Jb     Can5
           Mov    Dh,24
Can5:      Mov    ah,02h
           Int    10h

Ett:       Inc    Di
           Jmp    Short Nt
All:       Ret

Out_Text   Endp

Pass       Db 083h,78h



Code       Ends
           End Start